/* Copyright (C) 1999-2002 Stacey L. Keast <slik@telusplanet.net>
  
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software 
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef BBRB_H
#define BBRB_H

#ifdef HAVE_CONFIG_H
#include "../config.h"
#else
#define PACKAGE "bbrb"
#define VERSION "0.2"
#endif

#define HOMOGENEOUS TRUE
#define NON_HOMOGENEOUS FALSE
#define EXPAND_YES TRUE
#define EXPAND_NO FALSE
#define FILL_YES TRUE
#define FILL_NO FALSE
#define BORDER 3
#define NO_BORDER 0
#define SPACING 3
#define NO_SPACING 0
#define PADDING 3
#define NO_PADDING 0
#define ALLOW_SHRINK TRUE
#define DISALLOW_SHRINK FALSE
#define ALLOW_GROW TRUE
#define DISALLOW_GROW FALSE
#define ALLOW_AUTOSHRINK TRUE
#define DISALLOW_AUTOSHRINK FALSE

#include <gtk/gtk.h>
#include <gdk_imlib.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <unistd.h>
#include "thumbs.h"
#include "bbrblist.h"
#include "updatestyle.h"
#include "filefunctions.h"
#include "resetBB.h"

gint main (gint argc, gchar ** argv);

/*--- container widgets
-----------------------*/

GtkTooltips *tooltips;
gboolean bRandomize;
gint giNumberOfImageSetters;

GtkWidget *wpTopLevelWindow, *wpMainVBox,

/*
-- Containers
*/

/*top*/
 *BoxTopH, *BoxTopLeftV,	/*List */
 *wpPictureListScrolledWindow, *BoxTopMidV,	/*List Buttons */
 *BoxTopRightV,		/*Pixmap */
 *wpPixmap,
/*middle*/
 *BoxMidV,
/* image setters */
 *BoxImageSettersH,
/* xv */
  *BoxXVV,
 /* Fill-Misc */
  *BoxXVFillMiscH,
 /*Filling Options */
  *FrameXVFill, *BoxXVFillV,
 /*Tiling Options */
  *FrameXVTile, *BoxXVTileH, *BoxXVTileV1, *BoxXVTileV2,
 /*Misc Options */
  *FrameXVMisc, *BoxXVMiscV,
/* Esetroot */
 *FrameEsetroot, *BoxEsetrootV, *wpSeparator,
/*bottom - command buttons*/
 *BoxBotH;

/*--- button widgets
--------------------*/

/*topmid buttons*/
GtkWidget *wpAddButton, *wpRelabelButton, *wpRemoveButton;
  /*possably add some menu management buttons later */

/*mid radio buttons*/
GSList *wpImageSetterButtonGroup;

GSList *wpFillRadioButtonGroup;
GtkWidget *wpFillNo, *wpFillMax, *wpFillMaxAspect;

GSList *wpTileRadioButtonGroup;
GtkWidget *wpTile,
  *wpTileInteger,
  *wpTileMirrored,
  *wpTileIntegerMirrored,
  *wpTileCentered,
  *wpTileCenteredSolidBackground,
  *wpTileSymmetrical,
  *wpTileSymmetricalMirrored,
  *wpMiscReverseVideoCheckButton,
  *wpMiscHorizontalFlipCheckButton,
  *wpMiscVerticalFlipCheckButton, *wpMiscSmoothCheckButton;

GSList *wpEsetrootRadioButtonGroup;
GtkWidget *wpEsetrootTile,
  *wpEsetrootCentered, *wpEsetrootMax, *wpEsetrootMaxAspect,
/*bottom buttons*/
 *wpSetRootButton, *wpCancelButton;

/*bool to reduce toggle checks*/
gboolean ItemJustSelected;
gboolean ItemSelected;

/*--- methods
-------------*/

void createUI (void);

int bbrb_init (gint argc, gchar ** argv);

void bbrb_run (void);


/*--- callbacks
---------------*/

void destroy_CB (GtkWidget * wpWidget, gpointer dpData);

gboolean
delete_event_CB (GtkWidget * wpWidget, GdkEvent * epEvent, gpointer dpData);

void
listitem_selected (GtkWidget * widget, gint row, gint column,
		   GdkEventButton * event, gpointer data);

void
listitem_deselected (GtkWidget * widget, gint row, gint column,
		     GdkEventButton * event, gpointer data);

void bbrb_update_item (GtkWidget * widget, gpointer gdata);

void bbrb_list_remove (GtkWidget * widget, gpointer gdata);

void bbrb_set_root (GtkWidget * widget, gpointer gdata);

void bbrb_set_label (GtkWidget * widget, gpointer gdata);

void bbrb_list_sort (GtkWidget * widget, gpointer gdata);

void bbrb_update (GtkWidget * widget, gpointer gdata);

void bbrb_list_add (GtkWidget * widget, gpointer gdata);

void bbrb_randomize_toggled (GtkWidget * widget, gpointer gdata);

void bbrb_list_clear (GtkWidget * widget, gpointer gdata);

void bbrb_show_xv (GtkWidget * widget, gpointer gdata);

void bbrb_show_Esetroot (GtkWidget * widget, gpointer gdata);

void bbrb_set_default_toggles (void);
#endif /*BBRB_H */
