/* Copyright (C) 1999-2002 Stacey L. Keast <slik@telusplanet.net>
  
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
 
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software 
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef BBRBLIST_H
#define BBRBLIST_H
#ifdef _HAVE_CONFIG_H
#include "../config.h"
#endif
#include <gtk/gtk.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <malloc.h>
#include <time.h>
#include "filefunctions.h"
#include "filethumb.h"

/*data*/
GString *bbrb_label;
GString *bbrb_image_setter;
GString *default_image_setter;
GString *bbrb_file_name;
GString *bbrb_root_command;
GString *bbrb_fill;
GString *default_fill;
GString *bbrb_tile;
GString *default_tile;
GString *bbrb_reverse_video;
GString *default_reverse_video;
GString *bbrb_flip_horizontal;
GString *default_flip_horizontal;
GString *bbrb_flip_vertical;
GString *default_flip_vertical;
GString *bbrb_smooth;
GString *default_smooth;
GString *gsRandomPicStripped;
GtkWidget *wpClearButton;
GtkWidget *wpSortButton;
GtkWidget *wpUpdateButton;
GtkWidget *wpRandomizeButton;
GtkWidget *wpPictureList;
GtkWidget *wpEntryBox;
GtkWidget *wpFileThumb;
GtkWidget *wpXV;
GtkWidget *wpEsetroot;
guint giRows;
gint selected_row;
gboolean bInit;
gboolean bHaveXV;
gboolean bHaveEsetroot;

/*functions*/
void bbrb_load_list (void);

void PictureList_destroy (void);

int PictureList_init (void);

/*get functions*/
void PictureList_getRow (gint row);

gchar *PictureList_getRootCommand (gint row);

gchar *PictureList_getRandom (void);

/*set functions*/
void PictureList_setLabel (gint row);

void PictureList_update (void);

void PictureList_addRow (void);

void PictureList_add (void);

/*others*/
void destroy_dialog_CB (GtkWidget * widget, gpointer * data);

void dialog_relabel_ok (GtkWidget * widget, gpointer gdata);

#endif /*BBRBLIST_H */
