/* bbrbss Copyright (C) 1999-2001 by Stacey Keast <slik@telusplanet.net>
**
** This program is free software; you can redistribut it and/or modify it
** (please do) under the terms of the GNU General Public License as published
** by the Free Software Foundation; either version 2 of the License, or (at
** your option) any later version.
**
** This program is distributed in the hope that it will be useful, but
** WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
** or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
** for more details.
**
** You should have received a copy of the GNU General Public License along with
** this program; if not, write to the Free Software Foundation, Inc.,
** 675 Mass Ave, Cambridge, MA 02139, USA.
**
** (See the included file COPYING / GPL-2.0)
*/

#include "bbrbss.h"

int
main (int argc, char *argv[])
{
  int i, havespace = 0;
  if (argc != 2)
    {
      printf ("Usage: bbrbss \'ROOTCOMMAND\'\n");
      printf ("Try bbrbss --help for more information.\n");
    }
  else if (strcmp (argv[1], "--help") == 0)
    {
      printf
	("Usage: bbrbss \'ROOTCOMMAND\'\nReplace rootCommand: in current style with ROOTCOMMAND.\nThe new background image will appear and now be used on subsequent restarts.\n\n");
      printf
	("Example:\n\n  bbrbss \'xv -root -quit /path/to/my/pic.jpg\'\n\n");
      printf
	("NOTE:  This will not change your current style, but rather copy your current\n       style to ~/.blackbox/Styles/currentstyle and use it instead.\n");
    }
  else
    {
      for (i = 0; i < strlen (argv[1]); i++)
	{
	  if (argv[1][i] == ' ')
	    havespace = 1;
	}
      if (havespace)
	updatestyle (argv[1]);
      else
	printf
	  ("Invalid ROOTCOMMAND: \'%s\'\nTry bbrbss --help for an example.\n",
	   argv[1]);
    }
  return 0;
}
