/*
** Copyright (C) 1999-2002 Stacey L. Keast <slik@telusplanet.net>
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software 
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include "filefunctions.h"


void
getcurrentstyle (char *currentstyle)
{
  char *home;
  home = getenv ("HOME");
  strcpy (currentstyle, home);
  strcat (currentstyle, "/.blackbox/Styles/currentstyle");
}

int
getarg (char *getfile, char *getfield, char *arg)
{
  FILE *fp;
  extern int errno;
  char filebuffer[1024] = "", tempstr[1024] = "", ch;
  int i, ii, length, capture = 0;
  errno = 0;
  if ((fp = fopen (getfile, "r")) == NULL)
    {
      /*perror ("filefunctions:getarg:fp");*/
      return errno;
    }
  while ((fgets (filebuffer, 1024, fp)) != NULL)
    {
      if (capture)
	break;
      i = 0;
      length = strlen (filebuffer);
      for (ii = 0; ii < length; ii++)
	{
	  if ((ch = filebuffer[ii]) == ':')
	    {
	      if (strcmp (tempstr, getfield) == 0)
		capture = 1;
	      i = 0;
	    }
	  if (ch != 32 && ch != 9 && ch != ':' && ch != 10 && ch != 13)
	    {
	      tempstr[i] = (char) ch;
	      tempstr[i + 1] = '\0';
	      i++;
	    }
	}
    }
  if (capture)
      strcpy (arg, tempstr);
  else
    {
      errno = EINVAL;
      /*perror ("filefunctions:getarg:capture");*/
    }
  return errno;
}

int
setarg (char *setfile, char *setfield, char *arg)
{
  FILE *fpin, *fpout;
  extern int errno;
  char filebuffer[1024] = "", tempstr[1024] = "", ch, *backupfile;
  int i, ii, replace = 0, add = 1;
  errno = 0;
  backupfile = malloc (strlen (setfile) + 5);
  strcpy (backupfile, setfile);
  strcat (backupfile, ".old");
  if (errno = copyfile (backupfile, setfile))
    {
      /*perror ("filefunctions:setarg:copyfile");*/
      free (backupfile);
      return errno;
    }
  if ((fpin = fopen (backupfile, "r")) == NULL)
    {
      /*perror ("filefunctions:setarg:fpin");*/
      free (backupfile);
      return errno;
    }
  if ((fpout = fopen (setfile, "w")) == NULL)
    {
      /*perror ("filefunctions:setarg:fpout");*/
      free (backupfile);
      fclose (fpin);
      return errno;
    }
  while ((fgets (filebuffer, 1024, fpin)) != NULL)
    {
      i = 0;
      for (ii = 0; ii < strlen (filebuffer); ii++)
	{
	  if (((ch = filebuffer[ii]) == ':')
	      && (strcmp (tempstr, setfield) == 0))
	    {
	      replace = 1;
	      break;
	    }
	  /* if no whitespace */
	  if (ch != 32 && ch != 9)
	    {
	      tempstr[i] = (char) ch;
	      tempstr[i + 1] = '\0';
	      i++;
	    }
	}
      if (replace)
	{
	  fprintf (fpout, "%s: ", setfield);
	  fprintf (fpout, "%s\n", arg);
	  replace = 0;
	  add = 0;
	}
      else
	fputs (filebuffer, fpout);
    }
  if (add)
    {
      fprintf (fpout, "%s: ", setfield);
      fprintf (fpout, "%s\n", arg);
    }
  fclose (fpin);
  fclose (fpout);
  free (backupfile);
  return errno;
}

copyfile (char *dest, char *src)
{
  extern int errno;
  char c;
  FILE *fpin, *fpout;
  errno = 0;

  if ((fpin = fopen (src, "r")) == NULL)
    {
      /*printf ("*** %s in:\n", src);
      perror ("filefunctions:copyfile:fpin");*/
      return errno;
    }
  fpout = fopen (dest, "w");
  if (fpout == NULL)
    {
      /*printf ("*** %s in:\n", dest);
      perror ("filefunctions:copyfile:fpout");*/
      return errno;
    }
  while ((c = fgetc (fpin)) != EOF)
    fputc (c, fpout);
  fclose (fpin);
  fclose (fpout);
  return errno;
}
