/*
 * Copyright (C) 1999-2001 Stacey L. Keast <slik@telusplanet.net> 
 * This program is free software; you can redistribute it and/or modify 
 * it under the terms of the GNU General Public License as published by 
 * the Free Software Foundation; either version 2 of the License, or 
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
 */

#include "resetBB.h"
int
resetBB (void)
{
  extern int errno;
  int format_return;
  unsigned long nitems_return, bytes_left, lbpid;
  Display *dpy;
  Atom blackbox_pid, type_return;
  unsigned char *value;

  errno = 0;
  dpy = XOpenDisplay ((char *) 0);
  assert (dpy);
  if (blackbox_pid = XInternAtom (dpy, "_BLACKBOX_PID", True))
    {
      if (XGetWindowProperty
	  (dpy, DefaultRootWindow (dpy), blackbox_pid, 0, 1, False,
	   XA_CARDINAL, &type_return, &format_return, &nitems_return,
	   &bytes_left, &value) == Success)
	{
	  lbpid = (unsigned long) value[1];
	  lbpid = lbpid << 8;
	  lbpid += (unsigned long) value[0];
	  if (kill ((pid_t) lbpid, SIGUSR1))
	    {
	      perror ("Failure ");
	      XFree (value);
	      return -1;
	    }
	}
    }
  else
    {
      perror ("Failure ");
      return 1;
    }
  XFree (value);
  return 0;
}
