/*
** Copyright (C) 1999-2002 Stacey Keast <slik@telusplanet.net>
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software 
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include "textfuncs.h"

void extractpath (const gchar * imfname, GString * retname)
{
	gint last=0,i;
	for (i=0;imfname[i];i++)
	{
		if(imfname[i]=='/')
			last=i;
	}
	g_string_assign(retname,"");
	for (i=0;i<last;i++)
		g_string_append_c (retname, imfname[i]);
	g_string_append_c (retname, '/');
}

void
extractext (const gchar * imfname, GString * retname)
{
  gint separ = 0, i;
  gint length = strlen (imfname);
  for (i = 0; imfname[i]; i++)
    {
      if (imfname[i] == '.')
	separ = i + 1;
    }
  g_string_assign (retname, "");
  if (separ)
    {
      for (i = separ; i < length; i++)
	g_string_append_c (retname, imfname[i]);
    }
}

void
extractname (const gchar * imfname, GString * retname)
{
  gint last = -1, separ = -1, i;
  for (i = 0; imfname[i]; i++)
    {
      if (imfname[i] == '/')
	last = i + 1;
      if (imfname[i] == '.')
	separ = i;
    }
  g_string_assign (retname, "");
  for (i = last; i < separ; i++)
    g_string_append_c (retname, imfname[i]);
}
