/* Copyright (C) 1999-2002 by Stacey Keast <slik@telusplanet.net>
**
** This program is free software; you can redistribut it and/or modify it
** (please do) under the terms of the GNU General Public License as published
** by the Free Software Foundation; either version 2 of the License, or (at
** your option) any later version.
**
** This program is distributed in the hope that it will be useful, but
** WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
** or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
** for more details.
**
** You should have received a copy of the GNU General Public License along with
** this program; if not, write to the Free Software Foundation, Inc.,
** 675 Mass Ave, Cambridge, MA 02139, USA.
**
** (See the included file COPYING / GPL-2.0)
*/  
  
#include "thumbs.h"
  
GtkWidget * 
bbrb_show_thumb (gchar * spFilename, GtkWidget * wpPixMap,
				 gboolean bNew) 
{
	GdkImlibImage * im;
	GdkPixmap * p, *m;

	gint w, h;
	gfloat x, y;

	if (!strcmp (spFilename, "DEFAULTPIXMAP"))
		im = gdk_imlib_load_image (DEFAULTPIXMAP);
	else
		im = gdk_imlib_load_image (spFilename);
	
	w = im->rgb_width;
	h = im->rgb_height;
	
	if (w > h)
	{
		y = (gfloat) h / (gfloat) w;
		x = 1;
	}
	if (h > w)
    {
		x = (gfloat) w / (gfloat) h;
		y = 1;
	}
	if (w == h)
	{
		x = 1;
		y = 1;
	}
	x *= 150;
	y *= 150;
	gdk_imlib_render (im, (gint) x, (gint) y);
	p = gdk_imlib_move_image (im);
	m = gdk_imlib_move_mask (im);
	if (bNew)
		wpPixMap = gtk_pixmap_new (p, m);
	else
		gtk_pixmap_set (GTK_PIXMAP (wpPixMap), p, m);
	gdk_imlib_free_pixmap (p);
	gdk_imlib_free_pixmap (m);
	gdk_imlib_kill_image (im);
	gdk_flush ();
	return wpPixMap;
}
